%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018-2019  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_Elm_Delete(Element_list)

global ErrCode;

global DB_ELEMENTS;
global DB_PSETS;
global AST_NODES;
global AST_PSETS;

global AT_ELEMENTS;
global AT_PSETS;
global AT_NODES;

Element_list = unique(Element_list);

% Проверка существования в базе элементов
for i=1:size(Element_list,1)
    if (~DB_Elm_Exist(Element_list(i)))
        fprintf (1, '\nОшибка функции DB_Elm_Delete: элемент с номером %i отсутствует в базе !\n', Element_list(i));
        ErrCode = -1;
        return;
    end
end

% Внесение изменений в таблицу ассоциативности property set, а также в поля, на которые ссылаются property set
for i=1:size(Element_list,1)
    
    if (~isempty(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID))
        
        switch DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type
            
            case {'Quad', 'Tria'}
                
                DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Ori_Field_ID, Element_list(i));
                if (ErrCode < 0)
                    return;
                end
                
                DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Offset_Field_ID, Element_list(i));
                if (ErrCode < 0)
                    return;
                end
                
            case 'Bar'
                
                switch DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.type
                    
                    case 'PBUSH'

                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Ori_CID_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end
                        
                    case 'PROD'
                        
                        % Ничего не делаем
                        
                    case {'PBMSECT', 'PBRSECT', 'PBAR', 'PBARL', 'PBEAM', 'PBEAML', 'PBCOMP'}
                        
                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Ori_vector_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end
                        
                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Offset_vector_A_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end
                        
                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Offset_vector_B_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end
                        
                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Pinned_DOFs_A_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end
                        
                        DB_Field_Remove_Record(DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Pinned_DOFs_B_Field_ID, Element_list(i));
                        if (ErrCode < 0)
                            return;
                        end
                        
                    otherwise
                        
                        fprintf (1, '\nОшибка функции DB_Elm_Delete: обнаружен неизвестный тип property set балочного элемента с номером %i [%s] !\n', Element_list(i), DB_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.type);
                        fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                        ErrCode = -1;
                        return;
                    
                end
                
            case {'Tet', 'Wedge', 'Hex'}
                
                % Ничего не делаем
                
            otherwise
                fprintf (1, '\nОшибка функции DB_Elm_Delete: обнаружен неизвестный тип элемента с номером %i [%s] !\n', Element_list(i), DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.type);
                fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;
                
        end
        
        AST_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Elm_list = setdiff(AST_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Elm_list, Element_list(i));
        if (isempty(AST_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Elm_list))
            AST_PSETS{AT_PSETS(DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Prop_ID)}.Elm_list = [];
        end
        
    end

end

% Внесение изменений в таблицу ассоциативности узлов
for i=1:size(Element_list,1)

    Remove_Nodes_list = DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.Nodes;

    if (~isempty(Remove_Nodes_list))
        for j=1:size(Remove_Nodes_list,1)
            AST_NODES{AT_NODES(Remove_Nodes_list(j))}.Elm_list = setdiff(AST_NODES{AT_NODES(Remove_Nodes_list(j))}.Elm_list, Element_list(i));
            if (isempty(AST_NODES{AT_NODES(Remove_Nodes_list(j))}.Elm_list))
                AST_NODES{AT_NODES(Remove_Nodes_list(j))}.Elm_list = [];
            end
        end
    end

end

% Удаление элементов из базы данных и адресной таблицы
for i=1:size(Element_list,1)
    
    DB_ELEMENTS{AT_ELEMENTS(Element_list(i))}.ID = -1;
    AT_ELEMENTS(Element_list(i)) = 0;

end
